//
//  BookmarkItem.m
//  Dynamics
//
//  Created by Pierre d'Herbemont on Thu Jul 26 2001.
//		steg : steg@mac.com		
//
//  This 2 classes provide a way to add a 'bookmark' system like to Mandelbrot's Dynamics
//	Note that I move the Inspector in a new inspector which use panel, and bookmarks...
//	The bookmarks can be exported (.dynbm), and they are saved in a sort of preferences
//	file in ~/Library/DynamicsPrefs...
//  note that I changed nothing in your code, I only changed some link in IB for the
//	MandelView instance, for the new Inspector window.

#import "BookmarkItem.h"


@implementation BookmarkItem
-(id)init {
    self = [super init];
    [self setName:(NSString *)NSLocalizedString(@"untitled",@"untitled bookmarks")];
    [self setX:(NSDecimalNumber *)[NSDecimalNumber numberWithFloat:0.1211851]];
    [self setY:(NSDecimalNumber *)[NSDecimalNumber numberWithFloat:0.1211852]];
    [self setMagnitude:(NSDecimalNumber *)[NSDecimalNumber numberWithFloat:0.1211853]];
    [self setShading:(NSDecimalNumber *)[NSDecimalNumber numberWithFloat:2]];
    [self setIterations:(NSDecimalNumber *)[NSDecimalNumber numberWithFloat:100]];
    
    
    return self;
}


- (void)setName:(NSString *)nName{
    name = [nName copy];
}

-(void)setX:(NSDecimalNumber *)nX {
    x = [nX copy];
}

-(void)setY:(NSDecimalNumber *)nY {
    y = [nY copy];
}

-(void)setMagnitude:(NSDecimalNumber *)nMagnitude {
    magnitude = [nMagnitude copy];
}

- (void)setShading:(NSDecimalNumber *)nShading {
    shading = [nShading copy];
}

- (void)setIterations:(NSDecimalNumber *)nIterations {
    iterations = [nIterations copy];
}

- (NSString *)name {
    return name;
}

- (NSDecimalNumber *)x {
    return x;
}

- (NSDecimalNumber *)y {
    return y;
}

- (NSDecimalNumber *)magnitude {
    return magnitude;
}

- (NSDecimalNumber *)shading {
    return shading;
}

- (NSDecimalNumber *)iterations {
    return iterations;
}


- (id)initWithCoder:(NSCoder *)coder {
    [self setName:(NSString *)[coder decodeObject]];
    [self setX:(NSDecimalNumber *)[coder decodeObject]];
    [self setY:(NSDecimalNumber *)[coder decodeObject]];
    [self setMagnitude:(NSDecimalNumber *)[coder decodeObject]];
    [self setShading:(NSDecimalNumber *)[coder decodeObject]];
    [self setIterations:(NSDecimalNumber *)[coder decodeObject]];
    
    return self;
}
- (void)encodeWithCoder:(NSCoder *)coder {
    [coder encodeObject:[self name]];
    [coder encodeObject:[self x]];
    [coder encodeObject:[self y]];
    [coder encodeObject:[self magnitude]];
    [coder encodeObject:[self shading]];
    [coder encodeObject:[self iterations]];
}

@end
