//
//  BookmarksHandle.h
//  Dynamics
//
//  Created by Pierre d'Herbemont on Thu Jul 26 2001.
//		steg : steg@mac.com
//
//  This 2 classes provide a way to add a 'bookmark' system like to Mandelbrot's Dynamics
//	Note that I move the Inspector in a new inspector which use panel, and bookmarks...
//	The bookmarks can be exported (.dynbm), and they are saved in a sort of preferences
//	file in ~/Library/DynamicsPrefs...
//  note that I changed nothing in your code, I only changed some link in IB for the
//	MandelView instance, for the new Inspector window.

#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>

@interface BookmarksHandle : NSObject {
    NSMutableArray	*theBookmarks;
    id			Menu;
    id			bookmarksView;
    id			CenterxBox;
    id			CenteryBox;
    id			MagnificationBox;
    id			shadingBox;
    id			iterationsBox;
    id			aMandelView;
    
    /*inspector Panel*/
    NSPanel		*inspector;
    id				deleteButton;
    id				moreInfoButton;
    id				goToButton;
    
    /*More info Drawer*/
    NSDrawer		*moreInfo;
    id				infoxbox;
    id				infoybox;
    id				infoMagbox;
    id				infoNamebox;
    id				infoMandelView;
    id				infoShadingBox;
    id				infoIterationsBox;
}

/*memory and init functions*/
- (void)dealloc;
- (void)awakeFromNib;

/*useful for the data source connection*/
- (int)numberOfRowsInTableView:(NSTableView *)aTableView;
- (id)tableView:(NSTableView *)aTableView
    objectValueForTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex;
- (void)tableView:(NSTableView *)aTableView
    setObjectValue:anObject
    forTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex;

/*bookmarks handle*/
- (NSArray *)theBookmarks;
- (void)setBookmarks:(NSMutableArray *)nBoookmarks;
- (void)saveBookmarks;
- (void)openBookmarks;
- (void)saveBookmarksAs;

/*Connection with the resources*/
- (void)addItem:sender;
- (void)deleteItem:sender;
- (void)goItem:sender;
- (void)saveAsItem:sender;
- (void)openItem:sender;

- (void)toggleMoreInfo:sender;
- (void)updateBookmarkByMoreInfoOptionsWithPreviewUpdate:sender;
- (void)updateBookmarkByMoreInfoOptions:sender;
- (BOOL)updateMoreInfoWithMandelView:(BOOL)viewUpdate;
- (void)updateMoreInfoMandelView;

- (void)goFromBookmarksMenu:(NSMenuItem *)sender;
- (void)setBookmarksMenu;
/*NSTableView delegate stuff*/
- (void)tableViewSelectionDidChange:(NSNotification *)aNotification;
@end
