
#import <Cocoa/Cocoa.h>

@interface MandelView:NSView
{
	NSTimer 	*mandelTE;
        
        /* when drawing */
	double		screensize;
        double		line;
        double		printline;
        
        /* caching View */
        Boolean		tiffUpdate; /// -> maybe we don't need it anymore
        NSImageRep		*myImageRep;
        
        /* Coordinate */
	double		centerX, centerY;
	double		cwx, cwy; /* center of window */
	double		magnify; /* magnification factor */
	int		iterations;
	int		doShading;
        
    	double		oldcwx, oldcwy, oldmagnify;
        
        /* Cursor stuff */
        
        /* resources */
IBOutlet	id		JuliaView;
IBOutlet	id		IterationBox;
IBOutlet	id		ShadingBox;
IBOutlet	id		RangeBox;
IBOutlet	id		CenterxBox;
IBOutlet	id		CenteryBox;
IBOutlet	id		MagnificationBox;
        
        /* color stuff */
	double		myRed[100];
	double		myGreen[100];
	double		myBlue[100];
        
        NSRect		myBounds;
        
        /*zoom animation stuff*/
        double			step[4];
        double			current[4];
        int			positionInFrameForGrow;
        int			frameForGrow;
        NSRect			theRectForGrowTo;
}

- (IBAction)Reset:sender;
- (IBAction)ResetFromVariables:sender;
- (IBAction)UndoPic:sender;
- (IBAction)ReDraw:sender;
- (IBAction)ReCenter:sender;
- (IBAction)ChangeColors:sender;
- (IBAction)OriginalColors:sender;
- (IBAction)ResetFromVariables:sender;

- writeMandData:(NSMutableData *)theData;
- writeTIFFData:(NSMutableData *)theData;
- readData:(NSData *)theStream;

- (void) handlerForGrow:(NSTimer *)timer;
- (void) growRect:(NSRect)theRect;

- cleanupBadRead;
- finishRead;
- doLine:(BOOL)forPrinting;
- (void) handler1:(NSTimer *) Timer;


- (void)setCwx:(double)ncwx;
- (void)setCwy:(double)ncwy;
- (void)setMagnify:(double)nmag;
- (double)Cwx;
- (double)Cwy;
- (double)Magnify;
- (void)setIterations:(int)aInt;
- (int)iterations;
- (void)setShading:(int)aInt;
- (int)shading;
- (void)setImageRep:(NSBitmapImageRep *)aRep;
- (NSBitmapImageRep *)imageRep;

- (void)display;
- (void)stopMandelTE;

@end

@interface MyData:NSObject
{
        double			thecwx;
        double  		thecwy;
        double			themagnify;
        int			theiterations;
        int			theShading;
        NSRect			theFrameRect;
	NSImageRep		*theImageRep;
}

-(id)init :(double)cwx :(double)cwy :(double)magnify :(int)iterations :(int)Shading :(NSRect)FrameRect :(NSImageRep *)ImageRep;

-(double)Cwx;
-(double)Cwy;
-(double)Magnify;
-(int)Iterations;
-(int)Shading;
-(NSRect)FrameRect;
-(NSImageRep *)ImageRep;

- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;

@end

