
#import "MandelView.h"
#import "MyView.h"
#import	<stdlib.h>
#define	X				0
#define	Y				1
#define	HEIGHT				2
#define	WIDTH				3
#define	NUMBER_OF_FRAME_WHEN_ZOOMING	10
#define	NUMBER_OF_SEC_WHEN_ZOOMING	0.02

@implementation MandelView
- (void)resetCursorRects
{
        NSCursor *crosshairCursor = nil;
        if (!crosshairCursor) {
            NSImage *crosshairImage = [NSImage imageNamed:@"Cross"];
            NSSize imageSize = [crosshairImage size];
            crosshairCursor = [[NSCursor allocWithZone:[self zone]] initWithImage:crosshairImage 		hotSpot:NSMakePoint((imageSize.width / 2.0), (imageSize.height / 2.0))];
            [self addCursorRect:[self bounds] cursor:crosshairCursor];
        }

}

- (void) handler1:(NSTimer *) Timer
{
        [self doLine:NO];
}
- (void) handlerForGrow:(NSTimer *)timer
{
    int i;
    positionInFrameForGrow++;
    if(positionInFrameForGrow>frameForGrow)
    {
        [timer invalidate];
        tiffUpdate = YES;
        [self display];
    }else
    {
        for(i=0;i<4;i++)
            current[i]+=step[i];
        [self lockFocus];
            if(![[timer userInfo] drawInRect:NSMakeRect(current[X],current[Y],current[WIDTH],current[HEIGHT])])
                NSLog(@"ohoh : MandelView.m : '- (void) handler2ForGrow:(NSTimer *)timer can't draw in View Rect");
        [self unlockFocus];
        [[self window] flushWindow];
        
    }
}
- (void)growRect:(NSRect)theRect
{
    int	sec = NUMBER_OF_SEC_WHEN_ZOOMING;
    positionInFrameForGrow = 0;

    frameForGrow = NUMBER_OF_FRAME_WHEN_ZOOMING;
    
    if ([[NSApp currentEvent] modifierFlags] & NSShiftKeyMask)
    {
        frameForGrow	*=5;
        sec		*=5;
    }
    if ([[NSApp currentEvent] modifierFlags] & NSAlternateKeyMask)
    {
        frameForGrow	=2;
        sec		=0.02;
    }
    
    [self stopMandelTE];
    [myImageRep release];

    [self lockFocus];
        myImageRep = [[NSBitmapImageRep alloc] initWithFocusedViewRect:theRect];
    [self unlockFocus];
        current[X]	=theRect.origin.x;
        current[Y]	=theRect.origin.y;
        current[WIDTH]	=theRect.size.width;
        current[HEIGHT]	=theRect.size.height;
        step[X]		=(0-theRect.origin.x)/(double)frameForGrow;
        step[Y]		=(0-theRect.origin.y)/(double)frameForGrow;
        step[WIDTH]	=([self bounds].size.width-theRect.size.width)/(double)frameForGrow;
        step[HEIGHT]	=([self bounds].size.height-theRect.size.height)/(double)frameForGrow;
        
        [NSTimer scheduledTimerWithTimeInterval:sec 
				target:self 
				selector:@selector(handlerForGrow:) 
				userInfo:myImageRep 
				repeats:YES];
        
}

- convertToWorld:(NSPoint *)thePoint
	{
	double u, v, factor;
	
	factor = 4.1 / (screensize * magnify);
	u = (thePoint->x - centerX) * factor + cwx;
	v = (thePoint->y - centerY) * factor + cwy;
	thePoint->x = u; thePoint->y = v;
	return self;
	}

- convertToScreen:(NSPoint *)thePoint
	{
	double u, v, factor;
	
	factor = 4.1 / (screensize * magnify);
	u = (thePoint->x - cwx) / factor + centerX;
	v = (thePoint->y - cwy) / factor + centerY;
	thePoint->x = u; thePoint->y = v;
	return self;
	}

- doLine:(BOOL)forPrinting
{	
	int	i, j, count, colorcount, counttotal, previouscount;
	double	cx, cy, u, v, temp, factor, value, theline;
        NSPoint	aPoint;
        NSBezierPath *aPath;

        aPath = [NSBezierPath bezierPath];
        [aPath setLineWidth:2.0];
        

	if (forPrinting)
		theline = printline;
	else
		theline = line;
	if (! forPrinting)
		[self lockFocus];
	counttotal = iterations;
	j = [self bounds].size.width;
	factor = 4.1 / (screensize * magnify);
	previouscount = -1;
	for (i = 0; i < j; i++) 
		{
		u = 0; v = 0; count = 0;
		cx = (i - centerX) * factor + cwx;
		cy = (theline - centerY) * factor + cwy;
		while (((u * u + v * v) < 4.0) && (count < counttotal))
			{
			temp = u * u - v * v + cx;
			v = 2 * u * v + cy;
			u = temp;
			count = count + 1;
			}
		if (doShading == 1) {
			if (count != previouscount) {
				if (previouscount != -1) {
                                    aPoint.x = i - 1;
                                    aPoint.y = theline;
                                    [aPath lineToPoint:aPoint];
                                    [aPath stroke];
                                    aPath = [NSBezierPath bezierPath];
                                    [aPath setLineWidth:2.0];
                                    }
				value = count;
				value = 1.0 - value / counttotal;
                                [[NSColor colorWithDeviceRed:value 
                                    green:value blue:value alpha:1] set];
                                aPoint.x = i - 1;
                                aPoint.y = theline;
                                [aPath moveToPoint:aPoint];
                                /*
				PSmoveto(i, theline);*/
				}
			}
		else if (doShading == 0) {
			if (count != previouscount) {
                            if (previouscount == counttotal) {
                                aPoint.x = i - 1;
                                aPoint.y = theline;
                                [aPath lineToPoint:aPoint];
                            } 
				/*PSlineto(i - 1, theline);*/
                            else if (count == counttotal) {
                                aPoint.x = i- 1;
                                aPoint.y = theline;
                                [aPath moveToPoint:aPoint];
                            }
				/*PSmoveto(i, theline);*/
			}
			}
		else {
			if (count != previouscount) {
				if (previouscount != -1) {
                                    aPoint.x = i - 1;
                                    aPoint.y = theline;
                                    [aPath lineToPoint:aPoint];
                                    [aPath stroke];
                                    aPath = [NSBezierPath bezierPath];
                                    [aPath setLineWidth:2.0];
                                    /*[aPath reset];
                                    
					PSlineto(i - 1, theline);
					PSstroke();
                                     */
					}
				colorcount = count % 100;
				if (count == counttotal)
                                        [[NSColor blackColor] set];
				else
					[[NSColor colorWithDeviceRed:myRed[colorcount]
                                            green:myGreen[colorcount] blue:myBlue[colorcount]
                                            alpha:1] set];
                                aPoint.x = i - 1;
                                aPoint.y = theline;
                                [aPath moveToPoint:aPoint];
				}
			}
		previouscount = count;
		}
	if (doShading != 0) {
            aPoint.x = i;
            aPoint.y = theline;
            [aPath lineToPoint:aPoint];
            /*
		PSlineto(i, theline);
             */
		}
	else {
            if (count == counttotal) {
                aPoint.x = i;
                aPoint.y = theline;
                [aPath lineToPoint:aPoint];
            }
		/*PSlineto(i, theline);*/
		}

        [aPath stroke];
            /*PSstroke();*/
	if (doShading != 0)
                [[NSColor blackColor] set];
	if (! forPrinting) {
		line = line - 1;
		if (line < 0) {
			[self stopMandelTE];
                        [myImageRep release];
                        myImageRep = [[NSBitmapImageRep alloc] initWithFocusedViewRect:[self bounds]];
                        tiffUpdate = YES;
			}
	else
		printline = printline - 1;
		}
	if (! forPrinting) {
		[[self window] flushWindow];
		[self unlockFocus];
 		}
	return self;
}

- FixInspect
{
	[MagnificationBox setFloatingPointFormat:NO left:7 right:2];
	[CenterxBox setFloatingPointFormat:NO left:2 right:9];
	[CenteryBox setFloatingPointFormat:NO left:2 right:9];

	[MagnificationBox setFloatValue:magnify];
	[CenterxBox setFloatValue:cwx];
	[CenteryBox setFloatValue:cwy];
	return self;
}


- initVariables
{
	centerX = [self bounds].size.width / 2.0;
	centerY = [self bounds].size.height / 2.0;
	screensize = [self bounds].size.width;
	if (screensize > [self bounds].size.height)
		screensize = [self bounds].size.height;
	line = [self bounds].size.height;

        if(IterationBox)
        	iterations = [IterationBox intValue];
	if (iterations < 1) {
		iterations = 1;
		[IterationBox setIntValue:1];
		}
	if (iterations > 5000) {
		iterations = 5000;
		[IterationBox setIntValue:5000];
		}
        if(ShadingBox)
            doShading = [[ShadingBox selectedCell] tag];
	[self FixInspect];
	return self;
}

- (void)mouseDown:(NSEvent *)theEvent 
{	
	BOOL	shouldLoop = YES;
	BOOL	didDrag = NO;
	BOOL	didCancel = NO;
	NSRect	theRect;
	NSPoint	newPoint;
	NSPoint	center;
	NSEvent *nextEvent;
	double	a, b, c, d, e, f, temp, size;

	NSPoint where = [theEvent locationInWindow];
	where = [self convertPoint:where fromView:nil];
	[self lockFocus];
        // [[NSColor lightGrayColor] set];
        [[NSColor blackColor] set];
	[[self window] makeFirstResponder:self];
        theRect = NSMakeRect(where.x, where.y, 2, 2); 
        [[self window] cacheImageInRect:[self convertRect:theRect toView:nil]];
	/* PSsetinstance(YES); */
	while (shouldLoop) {
		nextEvent = [[self window] nextEventMatchingMask:NSLeftMouseDraggedMask|NSLeftMouseUpMask];
		switch ([nextEvent type]) {
			case NSLeftMouseDragged:	
                                                didDrag = YES;
						newPoint = [nextEvent locationInWindow];
						newPoint = [self convertPoint:newPoint fromView:nil];
                                                a = where.x; b = newPoint.x;
						if (a > b) {temp = a; a = b; b = temp;}
                                                e = b - a;
						c = where.y; d = newPoint.y;
                                                f = d - c;
                                                /* temp = oldheight, b = proportion
                                                    e = width		f = height*/
                                                temp=f;
                                                b=([self bounds].size.height)/([self bounds].size.width);
                                                f=(b)*e;//height = prop * width
                                                if(temp<0)
                                                    c=c-f;                                           
                                                if(e==0)
                                                    e=1;
                                                if(f==0)
                                                    f=1;
                                                [[self window] restoreCachedImage];
                                                theRect = NSMakeRect(a, c, e, f);
                                                [[self window] cacheImageInRect:
                                                            [self convertRect:theRect toView:nil]];
                                                NSFrameRect(theRect);
                                                [[self window] flushWindowIfNeeded];
						break;
			case NSLeftMouseUp:	shouldLoop = NO;
						if ([nextEvent modifierFlags] & NSCommandKeyMask)
							didCancel = YES;
                                                [[self window] restoreCachedImage];
                                                [[self window] flushWindowIfNeeded];
						/* PSnewinstance(); */
						/* PSsetinstance(NO); */
						break;
                        default: 		break;

			}
		}
	[self unlockFocus];
        [[NSColor blackColor] set];
	
	if (didDrag & (! didCancel)) {
		[[self window] setDocumentEdited:YES];
		center.x = theRect.origin.x + theRect.size.width / 2.0; 
		center.y = theRect.origin.y + theRect.size.height / 2.0;
		[self convertToWorld:&center];
		oldcwx = cwx; oldcwy = cwy; oldmagnify = magnify;
		cwx = center.x; cwy = center.y;
		size = theRect.size.width;
		if (size > theRect.size.height)
			size = theRect.size.height;
		if (size < 1.0) size = 1.0;
		magnify = magnify * (screensize / size);

		[self FixInspect];
		//[self initVariables];
                tiffUpdate = NO;
 		[self growRect:theRect];
		}
		
	else if (! didCancel) {
                    [self convertToWorld:&where];
                    [JuliaView RestartAt:&where];
                    }
}




- UndoPic:sender
{
	double tempcwx, tempcwy, tempmagnify;

	[self stopMandelTE];
	tempcwx = cwx; tempcwy = cwy; tempmagnify = magnify;
	cwx = oldcwx; cwy = oldcwy; magnify = oldmagnify;
	oldcwx = tempcwx; oldcwy = tempcwy; oldmagnify = tempmagnify;
	[self FixInspect];
	[self initVariables];
        tiffUpdate = NO;
	[self display];
	return self;
}


- (void)drawRect:(NSRect)rects{

        NSRect	tempBounds;
        
        tempBounds = myBounds;
        myBounds = [self bounds];
        if ((tempBounds.size.width != myBounds.size.width) || (tempBounds.size.height != myBounds.size.height))
        {
            tiffUpdate = YES;
        }
        [self stopMandelTE];
        [self initVariables];
        //if (tiffUpdate) {
		
 		/* myImageRep = [[NSBitmapImageRep
                        imageRepWithContentsOfFile:[[NSBundle mainBundle]
                         pathForImageResource:@"Full.tiff"]] retain]; */

		if (myImageRep != nil) {
			[self lockFocus];
			[myImageRep drawInRect:NSMakeRect(0,0,[self bounds].size.width,[self bounds].size.height)];
                        [[self window] flushWindow];
			[self unlockFocus];
			}
        //}

        
	if (! mandelTE) 
		mandelTE = [[NSTimer scheduledTimerWithTimeInterval:.002 
				target:self 
				selector:@selector(handler1:) 
				userInfo:nil 
				repeats:YES] retain];


}

- Reset:sender
{
	[self stopMandelTE];
	[[self window] setDocumentEdited:NO];
	oldcwx = cwx; oldcwy = cwy; oldmagnify = magnify;
	cwx = 0.0; cwy = 0.0;
	magnify = 1.0;
	[self FixInspect];
	[self initVariables];
        tiffUpdate = NO;
	[self display];
	return self;
}

- ResetFromVariables:sender
{
	[self stopMandelTE];
	[[self window] setDocumentEdited:NO];
	oldcwx = cwx; oldcwy = cwy; oldmagnify = magnify;
	magnify = [MagnificationBox floatValue];
	cwx = [CenterxBox floatValue];
	cwy = [CenteryBox floatValue];

	[self initVariables];
        tiffUpdate = NO;
	[self display];
	return self;
}


- ReDraw:sender
{

	[self stopMandelTE];
	[[self window] setDocumentEdited:YES];
	[self initVariables];
        tiffUpdate = NO;
	[self display];
	return self;
}

- ReCenter:sender
{
	[self stopMandelTE];
	[[self window] setDocumentEdited:YES];
	oldcwx = cwx; oldcwy = cwy; oldmagnify = magnify;
	cwx = [CenterxBox floatValue];
	cwy = [CenteryBox floatValue];
	magnify = [MagnificationBox floatValue];
	if (magnify > 100000000) {
		magnify = 100000000.0;
		[MagnificationBox setFloatValue:magnify];
		}
	[self initVariables];
        tiffUpdate = NO;
	[self display];
	return self;
}

- initWithFrame:(NSRect)frameRect
{
	int	i;

	self = [super initWithFrame:frameRect];
        [self initVariables];
        myBounds = [self bounds];
        myImageRep = [[NSBitmapImageRep
                        imageRepWithContentsOfFile:[[NSBundle mainBundle]
                         pathForImageResource:@"Full.tiff"]] retain];

	mandelTE = 0;
	cwx = 0.0; cwy = 0.0;
	magnify = 1.0;
	oldcwx = cwx; oldcwy = cwy; oldmagnify = magnify;
	[self FixInspect];
	/* myRed[0] = 0.0; myGreen[0] = 0.0; myBlue[0] = 0.0; */
	for (i = 0; i <= 20; i++) {
		myRed[i] = 1.0;
		myGreen[i] = i / 20.0;
		myBlue[i] = 0.0;
		}
	for (i = 21; i <= 30; i++) {
		myRed[i] = 1.0 * ((30 - i) / (30.0 - 21.0)) + .2 * ((i - 21) / (30.0 - 21.0)); 
		myGreen[i] = 1.0 * ((30 - i) / (30.0 - 21.0)) + .2 * ((i - 21) / (30.0 - 21.0));
		myBlue[i] = 0.0 + .2 * ((i - 21) / (30.0 - 21.0)); 
		}
	for (i = 31; i <= 90; i++) {
		myRed[i] = .2 * ((90 - i) / (90.0 - 31.0)) + 1.0 * ((i - 31) / (90.0 - 31.0)); 
		myGreen[i] = .2 * ((90 - i) / (90.0 - 31.0)) + 1.0 * ((i - 31) / (90.0 - 31.0));
		myBlue[i] = .2 * ((90 - i) / (90.0 - 31.0)) + 1.0 * ((i - 31) / (90.0 - 31.0)); 
		}
	for (i = 91; i < 100; i++) {
		myRed[i] = 1.0 * ((100 - i) / (100.0 - 91.0)) + 1.0 * ((i - 91) / (100.0 - 91.0)); 
		myGreen[i] = 1.0 * ((100 - i) / (100.0 - 91.0)) + 0.0 * ((i - 91) / (100.0 - 91.0));
		myBlue[i] = 1.0 * ((100 - i) / (100.0 - 91.0)) + 0.0 * ((i - 91) / (100.0 - 91.0)); 
		}

        tiffUpdate = YES;
	
	return self;
}

- writeMandData:(NSMutableData *)theData
{

	NSRect		theFrameRect, myRect;
	id		anImageRep;
	NSMutableData	*startData;
	MyData		*myData;
	NSArchiver	*archiver;
	
	[[self window] setDocumentEdited:NO];
		
        theFrameRect = [[self window] frame];
	[self lockFocus];
        myRect = [self bounds];
	anImageRep = [[NSBitmapImageRep alloc] initWithFocusedViewRect:myRect];
	myData = [[MyData alloc] init :cwx :cwy :magnify :iterations :doShading :theFrameRect :anImageRep];
	
	startData = [NSMutableData dataWithCapacity:0];
	archiver = [[NSArchiver alloc] initForWritingWithMutableData:startData];
	[archiver encodeRootObject:myData];
	[theData appendData:startData];
	[self unlockFocus];
	[anImageRep release];
	[myData release];
	[startData release];
	return self;
}

- writeTIFFData:(NSMutableData *)theData
{

	id		anImageRep;
	NSRect	myRect;
	
	[[self window] setDocumentEdited:NO];
	[self lockFocus];
	myRect = [self bounds];
	anImageRep = [[NSBitmapImageRep alloc] initWithFocusedViewRect:myRect];
	/*
	theStream = [myImageRep TIFFRepresentation];
	*/
        [theData appendData:[myImageRep TIFFRepresentation]];
	[anImageRep release];
	[self unlockFocus];

	return self;
}


- readData:(NSData *)theData
{
	id 		anImageRep;
	double		thecwx, thecwy, themagnify;
	int		theiterations, theShading;
	NSRect		theFrameRect;
	MyData		*myData;
	NSUnarchiver	*unarchiver;
	
	
	[[self window] setDocumentEdited:NO];
	unarchiver = [[NSUnarchiver alloc] initForReadingWithData:theData];
	myData = [unarchiver decodeObject];
	thecwx = [myData Cwx];
	thecwy = [myData Cwy];
	themagnify = [myData Magnify];
	theiterations = [myData Iterations];
	theShading = [myData Shading];
	theFrameRect = [myData FrameRect];
	anImageRep = [myData ImageRep];


	[self stopMandelTE];
	oldcwx = thecwx; oldcwy = thecwy; oldmagnify = themagnify;
	cwx = thecwx; cwy = thecwy; magnify = themagnify;
	iterations = theiterations;
	doShading = theShading;
	[IterationBox setIntValue:theiterations];
	[ShadingBox selectCellWithTag:doShading];
	line = -2;
	[[self window] setFrame:theFrameRect display:YES];
	[[self window] makeKeyAndOrderFront:self];
	[self FixInspect];
	[self initVariables];
	line = -2;
	
	if (anImageRep != nil) {
		/* [self lockFocus];
		[anImageRep draw];
		[self unlockFocus]; */
                [myImageRep release];
                [anImageRep retain];
                myImageRep = anImageRep;
                tiffUpdate = YES;
                [self display];
		/* [myImageRep release]; */
		}

	[myData release];

	return self;
}


- cleanupBadRead
{
	return self;
}

- finishRead
{
	return self;
}

void	getRandomColor(double *newRed, double *newGreen, double *newBlue)
{

	double	R, G, B;

	R = rand(); G = rand(); B = rand();
	R = R / 2147483647.0; G = G / 2147483647.0; B = B / 2147483647.0; 
	*newRed = R;
	*newGreen = G;
	*newBlue = B;
}

- ChangeColors:sender
{
	int	i, j, interval;
	double	oldRed, oldGreen, oldBlue;
	double	newRed, newGreen, newBlue;
	double	realinterval;

	[self stopMandelTE];
	
	interval = [RangeBox intValue];
	if (interval < 1) {
		interval = 1;
		[RangeBox setIntValue:1];
		}
	if (interval > 100) {
		interval = 100;
		[RangeBox setIntValue:1];
		}


	getRandomColor(&newRed, &newGreen, &newBlue);
	oldRed = newRed; oldGreen = newGreen; oldBlue = newBlue;

	for (i = 0; i < 100; i++) {
		j = i % interval;
		if (j == 0) j = interval;
		realinterval = interval;
		myRed[i] = oldRed * ((interval - j) / realinterval) + newRed * (j / realinterval);
		myGreen[i] = oldGreen * ((interval - j) / realinterval) + newGreen * (j / realinterval);
		myBlue[i] = oldBlue * ((interval - j) / realinterval) + newBlue * (j / realinterval);

		if ((i % interval) == 0) {
			oldRed = newRed; 
			oldGreen = newGreen;
			oldBlue = newBlue;
			getRandomColor(&newRed, &newGreen, &newBlue);
			}
		}
	
	[self initVariables];
        tiffUpdate = NO;
	[self display];
	
	return self;
}

- OriginalColors:sender
{
	int	i;

	[self stopMandelTE];
	
	/*
        interval = [RangeBox intValue];
	if (interval < 1) {
		interval = 1;
		[RangeBox setIntValue:1];
		}
	if (interval > 100) {
		interval = 100;
		[RangeBox setIntValue:1];
		}
        */


        for (i = 0; i <= 20; i++) {
		myRed[i] = 1.0;
		myGreen[i] = i / 20.0;
		myBlue[i] = 0.0;
		}
	for (i = 21; i <= 30; i++) {
		myRed[i] = 1.0 * ((30 - i) / (30.0 - 21.0)) + .2 * ((i - 21) / (30.0 - 21.0)); 
		myGreen[i] = 1.0 * ((30 - i) / (30.0 - 21.0)) + .2 * ((i - 21) / (30.0 - 21.0));
		myBlue[i] = 0.0 + .2 * ((i - 21) / (30.0 - 21.0)); 
		}
	for (i = 31; i <= 90; i++) {
		myRed[i] = .2 * ((90 - i) / (90.0 - 31.0)) + 1.0 * ((i - 31) / (90.0 - 31.0)); 
		myGreen[i] = .2 * ((90 - i) / (90.0 - 31.0)) + 1.0 * ((i - 31) / (90.0 - 31.0));
		myBlue[i] = .2 * ((90 - i) / (90.0 - 31.0)) + 1.0 * ((i - 31) / (90.0 - 31.0)); 
		}
	for (i = 91; i < 100; i++) {
		myRed[i] = 1.0 * ((100 - i) / (100.0 - 91.0)) + 1.0 * ((i - 91) / (100.0 - 91.0)); 
		myGreen[i] = 1.0 * ((100 - i) / (100.0 - 91.0)) + 0.0 * ((i - 91) / (100.0 - 91.0));
		myBlue[i] = 1.0 * ((100 - i) / (100.0 - 91.0)) + 0.0 * ((i - 91) / (100.0 - 91.0)); 
		}
	
	[self initVariables];
        tiffUpdate = NO;
	[self display];
	
	return self;
}
- (void)setCwx:(double)ncwx
{
    oldcwx=cwx;
    cwx=ncwx;
    [self FixInspect];
    tiffUpdate = NO;

}
- (void)setCwy:(double)ncwy
{
    oldcwy=cwy;
    cwy=ncwy;
    [self FixInspect];
    tiffUpdate = NO;

}
- (void)setMagnify:(double)nmag
{
    oldmagnify=magnify;
    magnify=nmag;
    [self FixInspect];
    tiffUpdate = NO;

}
-(double)Cwx
{
	return cwx;
}

-(double)Cwy
{
	return cwy;
}

-(double)Magnify
{
	return magnify;
}

- (void)setIterations:(int)aInt
{
    iterations = aInt;
}
- (int)iterations
{
    return iterations;
}
- (void)setShading:(int)aInt
{
    doShading = aInt;
}
- (int)shading
{
    return doShading;
}
- (void)setImageRep:(NSBitmapImageRep *)aRep
{
    [myImageRep release];
    myImageRep=[[NSBitmapImageRep alloc] initWithData:[aRep TIFFRepresentation]];
}
- (NSBitmapImageRep *)imageRep
{
    return myImageRep;
}

-(void)display
{
	[super display];
}
- (void)stopMandelTE
{
	if (mandelTE) {
		[mandelTE invalidate]; [mandelTE release];;
		mandelTE = 0;
		}
}
@end
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
@implementation MyData

-(id)init :(double)cwx :(double)cwy :(double)magnify :(int)iterations :(int)Shading :(NSRect)FrameRect :(NSImageRep *)ImageRep
{
	thecwx = cwx; thecwy = cwy; themagnify = magnify;
	theiterations = iterations; theShading = Shading;
	theFrameRect = FrameRect; theImageRep = ImageRep;

	return self;
}

-(double)Cwx
{
	return thecwx;
}

-(double)Cwy
{
	return thecwy;
}

-(double)Magnify
{
	return themagnify;
}

-(int)Iterations
{
	return theiterations;
}

-(int)Shading
{
	return theShading;
}

-(NSRect)FrameRect
{
	return theFrameRect;
}

-(NSImageRep *)ImageRep
{
	return theImageRep;
}




- (id)initWithCoder:(NSCoder *)coder
{
    [coder decodeValueOfObjCType:@encode(typeof(thecwx)) at:&thecwx];
    [coder decodeValueOfObjCType:@encode(typeof(thecwy)) at:&thecwy];
    [coder decodeValueOfObjCType:@encode(typeof(themagnify)) at:&themagnify];
    [coder decodeValueOfObjCType:@encode(typeof(theiterations)) at:&theiterations];
    [coder decodeValueOfObjCType:@encode(typeof(theShading)) at:&theShading];
    [coder decodeValueOfObjCType:@encode(typeof(theFrameRect)) at:&theFrameRect];

    theImageRep = [coder decodeObject];

    theImageRep = [theImageRep copy];

    return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
	[coder encodeValueOfObjCType:@encode(typeof(thecwx)) at:&thecwx];
	[coder encodeValueOfObjCType:@encode(typeof(thecwy)) at:&thecwy];
	[coder encodeValueOfObjCType:@encode(typeof(themagnify)) at:&themagnify];
	[coder encodeValueOfObjCType:@encode(typeof(theiterations)) at:&theiterations];
	[coder encodeValueOfObjCType:@encode(typeof(theShading)) at:&theShading];
	[coder encodeValueOfObjCType:@encode(typeof(theFrameRect)) at:&theFrameRect];
    	[coder encodeObject:theImageRep];
}


@end
