
#import "MyView.h"
#include <math.h>
#define HALF RAND_MAX / 2


@implementation MyView

- (void) handler:(NSTimer *) Timer
{
        [self doHundred:20];
}

- (void) handlerPoint:(NSTimer *) Timer
{
        [self doPoint];
}

- drawPointRect
{
	NSRect	theRect;
	theRect = NSMakeRect(ceil(thePointU * Magnify + centerX - 3), ceil(thePointV * Magnify + centerY - 3), 6, 6);
	NSFrameRect(theRect);
	return self; 	
}

- initVariables
{
	if (myTE) {
		[myTE invalidate]; [myTE release];
		myTE = 0;
		}
	x = 20.0;
	y = 20.0;
	thePointU = 0.0;
	thePointV = 0.0;
	return self;
}

- removePoint
{
	if (myPointTE) {
		[myPointTE invalidate]; [myPointTE release];
		myPointTE = 0;
		
		[self lockFocus];
                [[NSColor whiteColor] set];
		[self drawPointRect];
                [[NSColor blackColor] set];
		[self unlockFocus];
		[[self window] flushWindow];
		}
	
	return self;
}

- doPoint
{
	double	u, v;
	
	[self lockFocus];
        [[NSColor whiteColor] set];
	[self drawPointRect];
	
	u = thePointU * thePointU - thePointV * thePointV + cx;
	v = 2 * thePointU * thePointV + cy;
	thePointU = u;
	thePointV = v;
        [[NSColor blackColor] set];
	[self drawPointRect];
	[self unlockFocus];
	[[self window] flushWindow];
	if ((u * u + v * v) > 400)
		[self removePoint];
	return self;
}



- doHundred:(int)number
{
	int		i;
	double	temp, u, v;
        NSPoint	startpt, endpt;
        
	[self lockFocus];
	for (i = 0; i < number; i++) {
            startpt.x = x * Magnify + centerX - 1.0;
            startpt.y = y * Magnify + centerY;
            endpt.x = x * Magnify + centerX;
            endpt.y = y * Magnify + centerY;
            [NSBezierPath strokeLineFromPoint:startpt toPoint:endpt];
            /*
		PSmoveto(x * Magnify + centerX, y * Magnify + centerY);
		PSlineto(x * Magnify + centerX, y * Magnify + centerY);
             */
		u = x - cx;
		v = y - cy;
		temp = (u + sqrt(u * u + v * v)) / 2.0;
		if (temp < 0.0) temp = 0.0;
		temp = sqrt(temp);
		if (rand() < HALF)
			temp = - temp;
		if (fabs(temp) < 0.00001) {
			if (u >= 0.0) 
				y = 0.0;
			else
				y = sqrt(- u);
			x = 0.0;
			}
		else {
			x = temp;
			y = v / (2.0 * x);
			}
		}
	/* PSstroke(); */
	[self unlockFocus];
        [[self window] flushWindow];
	
	return self;
}

- Restart:sender
{
	
	[self initVariables];
	[self display];
    	return self;
}

- (void)drawRect:(NSRect)rects
{
	NSEraseRect([self bounds]);
        [[NSColor blackColor] set];
	centerX = [self bounds].size.width / 2.0;
	centerY = [self bounds].size.height / 2.0;
	Magnify = [self bounds].size.width / 2.8;
	if (Magnify > [self bounds].size.height / 2.5)
		Magnify = [self bounds].size.height / 2.8;
	Magnify = Magnify * [myScroller floatValue];
	if ( myTE == 0) { 
		myTE = [[NSTimer scheduledTimerWithTimeInterval:.002 target:self selector:@selector(handler:) userInfo:nil repeats:YES] retain];
		cx = [xValue floatValue];
		cy = [yValue floatValue];
		[pauseButton setState:0];
		}
	[self doHundred:1000];
}

- RestartAt:(NSPoint *)thePoint
{	
	[xValue setFloatValue:thePoint->x];
	[yValue setFloatValue:thePoint->y];
	[self initVariables];
	[self display];
	return self;
}

- initWithFrame:(NSRect)frameRect
{
	self = [super initWithFrame:frameRect];
	[self initVariables];
	myTE = 0; myPointTE = 0;
	return self;
}

- (void)mouseDown:(NSEvent *)theEvent 
{	

	NSPoint where = [theEvent locationInWindow];
	
	[self removePoint];
	if (!([theEvent modifierFlags] & NSCommandKeyMask)) {
	
		where = [self convertPoint:where fromView:nil];
		thePointU = (where.x - centerX) / Magnify; 
		thePointV = (where.y - centerY) / Magnify;
		
		[self lockFocus];
		[self drawPointRect];
		[self unlockFocus];
		[[self window] flushWindow];
		if (! myPointTE)
			myPointTE = [[NSTimer scheduledTimerWithTimeInterval:.9 target:self selector:@selector(handlerPoint:) userInfo:nil repeats:YES] retain];
		if (! myTE) {
			myTE = [[NSTimer scheduledTimerWithTimeInterval:.002  target:self selector:@selector(handler:) userInfo:nil repeats:YES] retain];
			}
		[pauseButton setState:0];
		}
}

- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent
{
	return YES;
}

- Pause:sender
{
	if ([sender state] == 1) {
		if (myPointTE) {
			[myPointTE invalidate]; [myPointTE release];;
			myPointTE = 0;
			}
		if (myTE) {
			[myTE invalidate]; [myTE release];;
			myTE = 0;
			}
		}
	else {
		if ((! myPointTE) && 
		((thePointU * thePointU + thePointV * thePointV) < 400)) {
			myPointTE = [[NSTimer scheduledTimerWithTimeInterval:.9 target:self selector: @selector(handlerPoint:) userInfo:nil repeats:YES] retain];
			}
		if (! myTE) {
			myTE = [[NSTimer scheduledTimerWithTimeInterval:.002 target:self selector:@selector(handler:) userInfo:nil repeats:YES] retain];
			}
		}

		 

	return self;
}

@end
